//=============================================================================
//
//  Copyright (c) Kitware, Inc.
//  All rights reserved.
//  See LICENSE.txt for details.
//
//  This software is distributed WITHOUT ANY WARRANTY; without even
//  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the above copyright notice for more information.
//
//  Copyright 2012 Sandia Corporation.
//  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
//  the U.S. Government retains certain rights in this software.
//
//=============================================================================
#ifndef __dax_exec_arg_Bind_h
#define __dax_exec_arg_Bind_h
#if defined(DAX_DOXYGEN_ONLY)

#else // !defined(DAX_DOXYGEN_ONLY)

#include <dax/Types.h>
#include <dax/cont/internal/Bindings.h>
#include <dax/cont/sig/Arg.h>
#include <dax/cont/sig/WorkId.h>
#include <dax/exec/arg/BindDirect.h>
#include <dax/exec/arg/BindWorkId.h>


namespace dax { namespace exec { namespace arg {

template <typename WorkType, typename Parameter, typename Invocation> class Bind;

template <typename WorkType, int N, typename Invocation>
class Bind<WorkType, dax::cont::sig::Arg<N>, Invocation>
{
public:
  typedef BindDirect<Invocation, N> type;
};

//bind workid in the execution signature to th bindworkId class
template <typename WorkType, typename Invocation>
class Bind<WorkType, dax::cont::sig::WorkId, Invocation>
{
public:
  typedef BindWorkId<Invocation> type;
};


}}} // namespace dax::exec::arg

#endif // !defined(DAX_DOXYGEN_ONLY)
#endif //__dax_exec_arg_Bind_h
